Attribute VB_Name = "imgctl_util"
' imgctl_util.bas
'	̃t@C̊֐͎Rɓ]pč\܂B
'	KvȂ̂̂݃Rs[ĂgB

Private Const DEF_JPEG_QUALITY = 100

' 摜t@CBMPt@Cɕϊ
Public Function ToBMP(BmpFile As String, ImageFile As String) As Boolean

	Dim hDIB As Long

	On Error Resume Next

	hDIB = ToDIB(ImageFile)
	If hDIB <> 0 Then
		ToBMP = CBool(DIBtoBMP(BmpFile, hDIB))
		DeleteDIB hDIB
	Else
		ToBMP = False
	End If

End Function

' 摜t@CJPEGt@Cɕϊ
Public Function ToJPG(JpegFile As String, ImageFile As String, _
Optional ByVal Quality As Integer = DEF_JPEG_QUALITY, _
Optional ByVal Progression As Boolean = False) As Boolean

	Dim hDIB As Long

	On Error Resume Next

	hDIB = ToDIB(ImageFile)
	If hDIB <> 0 Then
		ToJPG = CBool(DIBtoJPG(JpegFile, hDIB, CLng(Quality), CLng(Progression)))
		DeleteDIB hDIB
	Else
		ToJPG = False
	End If

End Function

' 摜t@CPNGt@Cɕϊ
Public Function ToPNG(PngFile As String, ImageFile As String, _
Optional ByVal Interlacing As Boolean = False) As Boolean

	Dim hDIB As Long

	On Error Resume Next

	hDIB = ToDIB(ImageFile)
	If hDIB <> 0 Then
		ToPNG = CBool(DIBtoPNG(PngFile, hDIB, CLng(Interlacing)))
		DeleteDIB hDIB
	Else
		ToPNG = False
	End If

End Function

' 摜t@CGIFt@Cɕϊ
Public Function ToGIF(GifFile As String, ImageFile As String, _
Optional ByVal Interlacing As Boolean = False) As Boolean

	Dim hDIB As Long

	On Error Resume Next

	hDIB = ToDIB(ImageFile)
	If hDIB <> 0 Then
		ToGIF = CBool(DIBtoGIF(GifFile, hDIB, CLng(Interlacing)))
		DeleteDIB hDIB
	Else
		ToGIF = False
	End If

End Function

' DIBtoPNGex ̎g (PNGOPTf[^^̐ݒ@)
Public Function MyDIBtoPNG(hDIB As Long, PngFile As String, _
Optional ByVal Trans As Long) As Boolean

	Dim po As PNGOPT
	Dim paltrns As PALTRANS

	On Error Resume Next

	'
	'	PNGOPTf[^^̊eϐ́AdwFlagɃtO𗧂ĂȂ
	'	LɂȂ܂(ݒ肵Ă܂)B
	'
		po.dwFlag = 0		' 

	'
	'	kx 0 ` 9 Őݒ肵܂B
	'	ݒ肵Ȃꍇ̓ftHg̈kɂȂ܂B
	'	ȂAJPEGƈႢA掿ɂ͉e܂B
	'
		po.dwFlag = po.dwFlag Or POF_COMPLEVEL	' tO𗧂Ă
		po.wCompLevel = 6

	'
	'	tB^^Cvݒ肵܂(w\)B
	'	ݒ肵Ȃꍇ̓tB^gpłB
	'	ʏ͎gȂĂǂł傤B
	'
		po.dwFlag = po.dwFlag Or POF_FILTER		' tO𗧂Ă
		po.dwFilter = PO_FILTER_NONE Or PO_FILTER_SUB

	'
	'	K}␳lݒ肵܂B
	'	ݒ肵Ȃꍇ͕Wlg܂B
	'	ʏ͎gȂĂǂł傤B
	'
		po.dwFlag = po.dwFlag Or POF_GAMMA		' tO𗧂Ă
		po.dwGamma = GAMMA_WIN

	'
	'	Fݒ肵܂B
	'	ݒ肵Ȃꍇ͓F͂܂B
	'	Wrbgȉ́Apbg݂DIBf[^̏ꍇA
	'	F̐ݒɂ́AFEpbgEx ̂Rނ
	'	ݒ@܂B
	'	16rbgȏDIBf[^̏ꍇAFŵ݉\łB
	'
		po.dwFlag = po.dwFlag Or POF_TRNSCOLOR	' tO𗧂Ă
		Select Case dwTrans
		'
		'	pbgŎw肷ꍇAclrTransɂ̓pbgԍ
		'	w肵܂BȂAsȃpbgԍw肵ꍇA
		'	ߏ͍s܂B
		'
		Case POF_TRNSPALETTE
			po.dwFlag = po.dwFlag Or POF_TRNSPALETTE	' tO𗧂Ă
			po.clrTrans = 25							' pbgԍݒ

		'
		'	xŎw肷ꍇAclrTransɂ́AepbgƂ
		'	xyя̗LZbgAPALTRANS\̂
		'	AhXZbg܂B
		'	x́A255 菬قǓxȂ܂B
		'	0 Ȃ犮SA255 Ȃ犮SsłB
		'	ȂAsSԂ̕\ɑΉĂuEÚA
		'	_ł Netscape 6.x ȍ~ ݂̂łB
		'
		Case POF_TRNSALPHA
			paltrns.trans(0) = 0					' Sɓ(wi)
			paltrns.trans(1) = 255					' Sɕs(ʏ)
			paltrns.trans(2) = 128					' x50
			paltrns.trans(3) = 64					' x75
			paltrns.dwNum = 4						' 0 ` 3 ̂S̏L
			po.dwFlag = po.dwFlag Or POF_TRNSALPHA	' tO𗧂Ă
			po.clrTrans = PointerOf(paltrns)		' \̂̃AhXݒ

		'
		'	Fw̏ꍇAclrTransɂCOLORREFlZbg܂B
		'	COLORREFlƂ 0x00BBGGRR ̌`ŕ\FłB
		'	̒ĺARGB}NgƂłݒł܂B
		'	RGB(, , ) ƂȂ܂B
		'	ȂAtJ[PNG(pbg)̓ߕ\o
		'	uEÚA_ł Netscape 6.x ȍ~ ݂̂łB
		'
		Case Else
			po.clrTrans = RGB(128, 0, 128)			' Zbg

		End Select

	'
	'	wiFݒ肵܂B
	'	ݒ肵Ȃꍇ͔wiF͂܂B
	'	Wrbgȉ́Apbg݂DIBf[^̏ꍇA
	'	ݒ@ɂ́AFEpbg ̂Qނ܂B
	'	ݒ@͓F̏ꍇƓȂ̂ŏȗ܂B
	'	wiFǂ́A摜r[ɂ܂B
	'	ʏ͎gȂĂǂł傤B
	'
		po.dwFlag = po.dwFlag Or POF_BACKCOLOR	' tO𗧂Ă
		po.clrBack = RGB(255, 255, 255)			' Zbg

	'
	'	t@Cɖߍޕݒ肵܂()B
	'	ݒ肵Ȃꍇ͉ߍ݂܂B
	'	܂APOF_TEXTCOMP ZbgƁÄk
	'	s܂B
	'	ʏ͎gȂĂǂł傤B
	'
		po.dwFlag = po.dwFlag Or POF_TEXT Or POF_TEXTCOMP	' tO𗧂Ă
		po.lpText = PointerOf("VtgJISᕶ邩˂B")
															' ̃AhXw

	'
	'	POF_INTERLACING ZbgƃC^[[XPNGɂȂ܂B
	'	uEUŌƁA摜WWƃ[h܂B
	'	POF_TIME ZbgƍXVԂ摜ɕۑ܂B
	'	ʏ͎gȂĂǂł傤B
	'
		po.dwFlag = po.dwFlag Or POF_INTERLACING Or POF_TIME

	'
	'	ĉQ̕ϐɂ 0 ĂĉB
	'
		po.dwReserved1 = 0
		po.dwReserved2 = 0

	MyDIBtoPNG = CBool(DIBtoPNGex(hDIB, PngFile, po))

End Function
